//+------------------------------------------------------------------+
//|                                                  EMA10xSMA50.mq4 |
//|                                                       Vixen Girl |
//|                                                vixenme@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Vixen Girl"
#property link      "vixenme@gmail.com"

//---- input parameters
extern bool    PutTP                         =false;
extern double  TakeProfit                    = 100.0;
extern double  Lots                          = 0.1;
extern bool    Put1stSL                      =false;
extern int     SLlevel                       = 50;
extern bool    enableTS                      =false;
extern double  TrailingStop                  = 38.0;
extern int     MagicNo                       = 888;

extern int     EMAPeriod                     = 10;
extern int     SMAPeriod                     = 50;

extern color   OpenBuy_Sig_Color             = SteelBlue;
extern color   CloseBuy_Sig_Color            = Black;
extern color   OpenSell_Sig_Color            = Red;
extern color   CloseSell_Sig_Color           = Black;
extern color   Modified_Sig_Color            = DarkViolet;

extern bool    Enable_Sound                  = True;
extern string  Sound_OrderOpen_FileName      = "alert.wav";
extern string  Sound_OrderClose_FileName     = "timeout.wav";
extern string  Sound_OrderModify_FileName    = "ok.wav";



//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNo)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+

//| expert initialization function |

//+------------------------------------------------------------------+

int init()

{

//----

//----

return(0);

}

//+------------------------------------------------------------------+

//| expert deinitialization function |

//+------------------------------------------------------------------+

int deinit()

{

//----

//----

return(0);

}

int Crossed (double line1 , double line2)
{
   static int last_direction = 0;
   static int current_dirction = 0;
   if(line1>line2)current_dirction = 1; //up
   if(line1<line2)current_dirction = 2; //down
   if(current_dirction != last_direction) //changed
   {
      last_direction = current_dirction;
      return (last_direction);
   }
   else
   {
      return (0);
   }
}

//+------------------------------------------------------------------+

//| expert start function |

//+------------------------------------------------------------------+

int start()

{

//----
   
   int cnt, ticket, total;
   int spread = MathRound((Ask-Bid)/Point);

   double FastMA, SlowMA,B4FastMA,B4SlowMA;
   FastMA = iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   SlowMA = iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   
   B4FastMA = iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   B4SlowMA = iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,1);

   int isCrossed = Crossed (FastMA,SlowMA);

   if(FastMA==SlowMA && B4FastMA<B4SlowMA)bool crossup=true;
   if(FastMA==SlowMA && B4FastMA>B4SlowMA)bool crossdn=true;

   if(PutTP)
   {
      if(crossup)double   IfTakeProfit=Ask+TakeProfit*Point;
      if(crossdn)         IfTakeProfit=Bid-TakeProfit*Point;
   }else IfTakeProfit=0;

   if(Put1stSL)
   {
      if(crossup)double   F1stSL=Ask-SLlevel*Point;
      if(crossdn)         F1stSL=Bid+SLlevel*Point;
   }else F1stSL=0;


   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);
   }

   if(TakeProfit<10)
   {
      Print("TakeProfit less than 10");
      return(0); // check TakeProfit
   }

   if(AccountFreeMargin()<(1000*Lots))
   {
      Print("You have no money left for running order. Free Margin Left : ", AccountFreeMargin());
      return(0);
   }


   total = OrdersTotal();

   if(CalculateCurrentOrders(Symbol())==0)
   {
      if(crossup)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,spread,F1stSL,IfTakeProfit,NULL,MagicNo,0,OpenBuy_Sig_Color);

         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            if (Enable_Sound) PlaySound(Sound_OrderOpen_FileName);
            Comment("\nMA Cross : Buy Alert : ", TimeToStr(CurTime(),TIME_MINUTES),
                     "\nOrder Opened : ",OrderOpenPrice());
            Print("BUY order opened : ",OrderOpenPrice());
         }
         else Print("Error opening BUY order : ",GetLastError());
         return(0);
      }

      if(crossdn)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,spread,F1stSL,IfTakeProfit,NULL,MagicNo,0,OpenSell_Sig_Color);

         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               if (Enable_Sound) PlaySound(Sound_OrderOpen_FileName);
               Comment("\nMA Cross : Sell Alert : ", TimeToStr(CurTime(),TIME_MINUTES),
                        "\nOrder Opened : ",OrderOpenPrice());
               Print("SELL order opened : ",OrderOpenPrice());
         }
         else Print("Error opening SELL order : ",GetLastError());
         return(0);
      }

   return(0);
   }

   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
      {
         if(OrderType()==OP_BUY) // long position is opened
         {
            // should it be closed?
            if(crossdn)
            {
               OrderClose(OrderTicket(),OrderLots(),Bid,spread,CloseBuy_Sig_Color);
                  if (Enable_Sound) PlaySound(Sound_OrderClose_FileName);
                  Comment("\nLong Order Closed : ",OrderTicket(),
                           "At : ",OrderClosePrice(),
                           "\nProfit : ",OrderProfit(),
                           "\nTime : ", TimeToStr(CurTime(),TIME_MINUTES));
               // close position
               return(0); // exit
            }
            // check for trailing stop
            if(enableTS)
            {
               if(TrailingStop>0)
               {
                  if(Bid-OrderOpenPrice()>Point*TrailingStop)
                  {
                     if(OrderStopLoss()<Bid-Point*TrailingStop ||(OrderStopLoss()==0))
                     {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Modified_Sig_Color);
                        if (Enable_Sound) PlaySound(Sound_OrderModify_FileName);
                           Comment("\nOrder Modify Alert : ",TimeToStr(CurTime(),TIME_MINUTES),
                                    "\nNew Stop Loss : ",OrderStopLoss(),
                                    "\nNew Target Profit : ",OrderTakeProfit());
                        return(0);
                     }
                  }
               }
            }
         }
         else // go to short position
         {
            // should it be closed?
            if(crossup)
            {
               OrderClose(OrderTicket(),OrderLots(),Ask,spread,CloseSell_Sig_Color);
                  if (Enable_Sound) PlaySound(Sound_OrderClose_FileName);
                  Comment("\nShort Order Closed : ",OrderTicket(),
                           "At : ",OrderClosePrice(),
                           "\nProfit : ",OrderProfit(),
                           "\nTime : ", TimeToStr(CurTime(),TIME_MINUTES));
               // close position
               return(0); // exit
            }
            // check for trailing stop
            if(enableTS)
            {
               if(TrailingStop>0)
               {
                  if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                  {
                     if((OrderStopLoss()>(Ask+Point*TrailingStop)) ||(OrderStopLoss()==0))
                     {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Modified_Sig_Color);
                        if (Enable_Sound) PlaySound(Sound_OrderModify_FileName);
                           Comment("\nOrder Modify Alert : ",TimeToStr(CurTime(),TIME_MINUTES),
                                    "\nNew Stop Loss : ",OrderStopLoss(),
                                    "\nNew Target Profit : ",OrderTakeProfit());
                        return(0);
                     }
                  }
               }
            }
         }
      }
   }




return(0);
}


//+------------------------------------------------------------------+

